//+------------------------------------------------------------------+
//|                                                  WeeklyPivot.mq4 |
//|  I found the original indicator in TSD forum posted by heliyaun. |
//|    Thanks to mladen for help me to fix the labels redraw problem |
//|                                                                  |
//|                                               Linuxser, May 2008 |
//|                                                                  |
//+------------------------------------------------------------------+
//|                                           Re-Written by Linuxser |   
//|                                       http://www.linuxser.com.ar |                               
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 C'55,98,223'
#property indicator_color2 C'55,98,223'
#property indicator_color3 C'55,98,223'
#property indicator_color4 C'55,98,223'
#property indicator_color5 C'55,98,223'
#property indicator_color6 C'55,98,223'
#property indicator_color7 C'55,98,223'

#property indicator_style1 STYLE_DASHDOTDOT
#property indicator_style2 STYLE_DASHDOTDOT
#property indicator_style3 STYLE_DASHDOTDOT
#property indicator_style4 STYLE_DASHDOTDOT
#property indicator_style5 STYLE_DASHDOTDOT
#property indicator_style6 STYLE_DASHDOTDOT
#property indicator_style7 STYLE_DASHDOTDOT

//---- input parameters

extern color     LabelColor= C'55,98,223';
extern int       fontsize=8;
extern int       LabelShiftToRight = 10;
int nDigits;
//---- buffers
double PBuffer[];
double S1Buffer[];
double R1Buffer[];
double S2Buffer[];
double R2Buffer[];
double S3Buffer[];
double R3Buffer[];
string Pivot="WeeklyPivotPoint",Sup1="W_S 1", Res1="W_R 1";
string Sup2="W_S 2", Res2="W_R 2", Sup3="W_S 3", Res3="W_R 3";
double WP,WS1,WR1,WS2,WR2,WS3,WR3;
double last_week_high, last_week_low, this_week_open, last_week_close;
datetime LabelShiftTime;
double LastRedraw = 0;
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("WeeklyPivot");
   ObjectDelete("WSup1");
   ObjectDelete("WRes1");
   ObjectDelete("WSup2");
   ObjectDelete("WRes2");
   ObjectDelete("WSup3");
   ObjectDelete("WRes3");   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,EMPTY);
   SetIndexStyle(1,DRAW_LINE,EMPTY);
   SetIndexStyle(2,DRAW_LINE,EMPTY);
   SetIndexStyle(3,DRAW_LINE,EMPTY);
   SetIndexStyle(4,DRAW_LINE,EMPTY);
   SetIndexStyle(5,DRAW_LINE,EMPTY);
   SetIndexStyle(6,DRAW_LINE,EMPTY);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,S1Buffer);
   SetIndexBuffer(2,R1Buffer);
   SetIndexBuffer(3,S2Buffer);
   SetIndexBuffer(4,R2Buffer);
   SetIndexBuffer(5,S3Buffer);
   SetIndexBuffer(6,R3Buffer);
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);


//---- name for DataWindow and indicator subwindow label
   short_name="Pivot Point Weekly";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
   if(Symbol()=="GBPJPY" || Symbol()=="EURJPY" || Symbol()=="USDJPY" || Symbol()=="GOLD" || Symbol()=="USDMXN") nDigits = 2;
   if(Symbol()=="GBPUSD" || Symbol()=="EURUSD" || Symbol()=="NZDUSD" || Symbol()=="USDCHF"  ||
   Symbol()=="USDCAD" || Symbol()=="AUDUSD" || Symbol()=="EURUSD" || Symbol()=="EURCHF"  || Symbol()=="EURGBP"
   || Symbol()=="EURCAD" || Symbol()=="EURAUD" || Symbol()=="AUDNZD")nDigits = 4;

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)
{
   if(Period() > 1440)
   {
   Print("Error - Chart period is greater than 1 day.");
   return(-1); // then exit
   }
   
}
   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;


for (i=limit; i>=0;i--)
{ 


   // Monday
	if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
	{
		last_week_close = Close[i+1];
		this_week_open = Open[i];

		// WeeklyPivot
	WP = (last_week_high + last_week_low + last_week_close) / 3;

   WR1 = (2*WP)-last_week_low;
   WS1 = (2*WP)-last_week_high;
   WR2 = WP+(last_week_high - last_week_low);
   WS2 = WP-(last_week_high - last_week_low);
   WR3 = (2*WP)+(last_week_high-(2*last_week_low));
   WS3 = (2*WP)-((2* last_week_high)-last_week_low); 
  
   last_week_low=Low[i]; last_week_high=High[i];   

}   
    
    last_week_high = MathMax(last_week_high, High[i]);
 	 last_week_low = MathMin(last_week_low, Low[i]);   
    PBuffer[i]=WP;
    S1Buffer[i]=WS1;
    R1Buffer[i]=WR1;
    S2Buffer[i]=WS2;
    R2Buffer[i]=WR2;
    S3Buffer[i]=WS3;
    R3Buffer[i]=WR3;

}

   if(TimeLocal() - LastRedraw > 600)   
   {
   Print(i);
   init_pivots();
   Print("Redrawing W Pivot Labels after 10 minutes have elapsed since the last Redraw!"); 
   Print("ObjectMove Done");
   
   ObjectsRedraw(); 
   Print("Weekly ObjectsRedraw Done");
   LastRedraw = TimeLocal();
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+
void init_pivots()
{
 //LabelShiftTime = Time[LabelShift];
   LabelShiftTime = (Time[0]+Period()*60*MathAbs(LabelShiftToRight));

	ObjectCreate("WeeklyPivot", OBJ_TEXT, 0,LabelShiftTime,0);
   ObjectSetText("WeeklyPivot", "W Pivot "+DoubleToStr(WP,nDigits),fontsize,"Trebuchet MS",LabelColor);
   ObjectSet("WeeklyPivot",OBJPROP_BACK,1);
   ObjectMove("WeeklyPivot", 0, LabelShiftTime,WP);
   ObjectCreate("WSup1", OBJ_TEXT, 0, 0, 0);
   ObjectSetText("WSup1", "W S1 "+DoubleToStr(WS1,nDigits),fontsize,"Trebuchet MS",LabelColor);
   ObjectSet("WSup1",OBJPROP_BACK,1);
   ObjectMove("WSup1", 0, LabelShiftTime,WS1);
   ObjectCreate("WRes1", OBJ_TEXT, 0, LabelShiftTime, 0);
   ObjectSetText("WRes1", "W R1 "+DoubleToStr(WR1,nDigits),fontsize,"Trebuchet MS",LabelColor);
   ObjectSet("WRes1",OBJPROP_BACK,1);
   ObjectMove("WRes1", 0, LabelShiftTime,WR1);
   ObjectCreate("WSup2", OBJ_TEXT, 0, LabelShiftTime, 0);
   ObjectSetText("WSup2", "W S2 "+DoubleToStr(WS2,nDigits),fontsize,"Trebuchet MS",LabelColor);
   ObjectSet("WSup2",OBJPROP_BACK,1);
   ObjectMove("WSup2", 0, LabelShiftTime,WS2);
   ObjectCreate("WRes2", OBJ_TEXT, 0, LabelShiftTime, 0);
   ObjectSetText("WRes2", "W R2 "+DoubleToStr(WR2,nDigits),fontsize,"Trebuchet MS",LabelColor);
   ObjectSet("WRes2",OBJPROP_BACK,1);
   ObjectMove("WRes2", 0, LabelShiftTime,WR2);
   ObjectCreate("WSup3", OBJ_TEXT, 0, LabelShiftTime, 0);   
   ObjectSetText("WSup3", "W S3 "+DoubleToStr(WS3,nDigits),fontsize,"Trebuchet MS",LabelColor);
   ObjectSet("WSup3",OBJPROP_BACK,1);
   ObjectMove("WSup3", 0, LabelShiftTime,WS3);
   ObjectCreate("WRes3", OBJ_TEXT, 0, LabelShiftTime, 0);   
   ObjectSetText("WRes3", "W R3 "+DoubleToStr(WR3,nDigits),fontsize,"Trebuchet MS",LabelColor);
   ObjectSet("WRes3",OBJPROP_BACK,1);   
   ObjectMove("WRes3", 0, LabelShiftTime,WR3);
   Print("ObjectSet Done");
}   